#include <windows.h>
#include "antlock.h"

void ant_init(ant_lock *lock)
{
	InitializeCriticalSection(&lock->c_sec);
	lock->h_event = CreateEvent(NULL, TRUE, TRUE, NULL);
	lock->count   = 0;
}

void ant_lock_shared(ant_lock *lock)
{
	EnterCriticalSection(&lock->c_sec);
	ResetEvent(lock->h_event);
	++lock->count;
	LeaveCriticalSection(&lock->c_sec);
}

void ant_unlock_shared(ant_lock *lock)
{
	EnterCriticalSection(&lock->c_sec);

	if (--lock->count == 0) {
		SetEvent(lock->h_event);
	}
	LeaveCriticalSection(&lock->c_sec);
}

void ant_lock_exclusive(ant_lock *lock)
{
again:;
	WaitForSingleObject(lock->h_event, INFINITE);
	EnterCriticalSection(&lock->c_sec);
	
	if (lock->count != 0) {
		LeaveCriticalSection(&lock->c_sec);
		goto again;
	}
}

void ant_unlock_exclusive(ant_lock *lock)
{
	LeaveCriticalSection(&lock->c_sec);
}